HepMC3 event record library: RelativesInterface< Relative_type > Class Template Reference

HepMC3 event record library

Public Member Functions | Static Public Attributes | Private Attributes
RelativesInterface< Relative_type > Class Template Reference

## Detailed Description

template<typename Relative_type>
class HepMC3::RelativesInterface< Relative_type >

forward declare the Relatives interface in which _parents and _children are wrapped

wrap a templated class that implements Relatives Since we need to template the functionality on the input type (GenParticlePtr, ConstGenVertexPtr etc.) we must wrap a class that has a templated operator in this that provides the Relatives interface and calls through to the underlying template method.

Definition at line 217 of file Relatives.h.

`#include <Relatives.h>`

Inheritance diagram for RelativesInterface< Relative_type >:
[legend]
Collaboration diagram for RelativesInterface< Relative_type >:
[legend]

## Public Member Functions
GenParticles_type< GenParticlePtr > | operator() (GenParticlePtr input) const override
| Operator.
GenParticles_type< ConstGenParticlePtr > | operator() (ConstGenParticlePtr input) const override
| Operator.
GenParticles_type< GenVertexPtr > | operator() (GenVertexPtr input) const override
| Operator.
GenParticles_type< ConstGenVertexPtr > | operator() (ConstGenVertexPtr input) const override
| Operator.

## Static Public Attributes
static HEPMC3search_Relatives_EXPORT_API const Parents | PARENTS
| Parents.
static HEPMC3search_Relatives_EXPORT_API const Children | CHILDREN
| Children.
static HEPMC3search_Relatives_EXPORT_API const Ancestors | ANCESTORS
| Ancestors.
static HEPMC3search_Relatives_EXPORT_API const Descendants | DESCENDANTS
| Descendants.

## Private Attributes
Relative_type | _internal
| Internal relatives code.

## Constructor & Destructor Documentation

## ◆ RelativesInterface()

template<typename Relative_type>

RelativesInterface | ( |  | ) |
| inlineconstexpr

Definition at line 220 of file Relatives.h.

## Member Function Documentation

## ◆ operator()() [1/4]

template<typename Relative_type>

GenParticles_type< ConstGenParticlePtr > operator() | ( | ConstGenParticlePtr | input | ) | const
| inlineoverridevirtual

Operator.

Implements Relatives.

Definition at line 225 of file Relatives.h.

## ◆ operator()() [2/4]

template<typename Relative_type>

GenParticles_type< ConstGenVertexPtr > operator() | ( | ConstGenVertexPtr | input | ) | const
| inlineoverridevirtual

Operator.

Implements Relatives.

Definition at line 229 of file Relatives.h.

## ◆ operator()() [3/4]

template<typename Relative_type>

GenParticles_type< GenParticlePtr > operator() | ( | GenParticlePtr | input | ) | const
| inlineoverridevirtual

Operator.

Implements Relatives.

Definition at line 223 of file Relatives.h.

## ◆ operator()() [4/4]

template<typename Relative_type>

GenParticles_type< GenVertexPtr > operator() | ( | GenVertexPtr | input | ) | const
| inlineoverridevirtual

Operator.

Implements Relatives.

Definition at line 227 of file Relatives.h.

## Field Documentation

## ◆ _internal

template<typename Relative_type>

Relative_type _internal
| private

Internal relatives code.

Definition at line 233 of file Relatives.h.

## ◆ ANCESTORS

const Ancestors ANCESTORS
| thread_localstaticinherited

Ancestors.

Definition at line 203 of file Relatives.h.

## ◆ CHILDREN

const Children CHILDREN
| staticinherited

Children.

Definition at line 202 of file Relatives.h.

## ◆ DESCENDANTS

const Descendants DESCENDANTS
| thread_localstaticinherited

Descendants.

Definition at line 204 of file Relatives.h.

## ◆ PARENTS

const Parents PARENTS
| staticinherited

Parents.

Definition at line 201 of file Relatives.h.

The documentation for this class was generated from the following file:

- Relatives.h